// version number intentionally omitted

clear all

// Test 1
//   For small n, -nchooseki <n> <k>- should produce the same result
//   as directly calculating n!/((n-k)!k!).


/*
       Certification, test 1.

       For small n, above code should produce the same result 
       as directly calculating n!/((n-k)!k!) for k=0 to n+1. 
*/

program factorial
        args scaname colon n
        scalar `scaname' = round(exp(lnfactorial(`n')), 1)
end

program nk, rclass
        args scaname colon n k 

        tempname nmk nf nmkf kf 

        local nmk = `n'-`k'

        factorial `nf'   : `n'
        factorial `nmkf' : `nmk' 
        factorial `kf'   : `k'

        scalar `scaname' = `nf'/(`nmkf'*`kf')
end


program check_small_values
        tempname C
        forvalues n=1(1)5 {
                local np1 = `n' + 1
                forvalues k=0(1)`np1' {
                        nk   `C' : `n' `k'
                        nchooseki  `n' `k'
                        assert `C'==r(comb) 
                }
        }
end
check_small_values

nchooseki 5 0 
assert r(comb)==1
nchooseki 5 6
assert r(comb)==.


// Test 2
//   -nchooseki- should produce results when direct calculation
//   fails.

nchooseki 1000 1
assert r(comb)==1000
nchooseki 1000 2
assert r(comb)==1000*999/2
nchooseki 1000 1000
assert r(comb) == 1
nchooseki 1000 999
assert r(comb) == 1000
nchooseki 1000 998
assert r(comb)==1000*999/2

// Test 3
//   Missing values.

nchooseki -1  1
assert r(comb)==.
nchooseki  1 -1
assert r(comb)==.
rcof "noisily nchooseki  5  ." == 7 
rcof "noisily nchooseki  .  2" == 7
rcof "noisily nchooseki  .  2" == 7
rcof "noisily nchooseki  .  ." == 7
rcof "noisily nchooseki  .  2" == 7

// Test 4
//   Invalid syntax.

rcof "noisily nchooseki"        == 7
rcof "noisily nchooseki 10"     == 7
rcof "noisily nchooseki 10 5 3" == 198
